// this is a fucken script

var
	curX, curY : integer;
	menu_item : byte;
	menu_page : byte;
	strs : TStrings;
	
//	hangup_controls : boolean;
	assert_text : string;
	assert_need_ok : boolean;
	chatroom_show : boolean;
	chat_msg : string;
	isServer : boolean;
	spawning : byte;
	loading_pat : byte;
	mn14: string;
	gtime : cardinal;
	online : boolean;
	remember_password : boolean;
	replay_avail : boolean;

	edit_login : string;
	edit_pass : string;
	edit_mail : string;
	edit_hostname : string;
	edit_replayname : string;
	edit_focused : byte;
	online_page : byte;
	online_selected_serv : integer;
	online_selected_serv_setting : integer;
	
	opt_selected_monitor : integer;
	opt_selected_mode : integer;
	opt_selected_resolution : integer;
	opt_video_changes : boolean;
	opt_video_w : integer;
	opt_video_h : integer;	
	opt_page : integer;

	hot_topic, hot_url : string;

function CursorInRegion(x,y,w,h:integer);
begin
	result := (curx >= x) and (curx <= x + w) and (cury >= y) and (cury <= y+h);
end;

procedure SetMenuPage(Page : byte);
begin
	menu_page := Page;
	declare_menupage(page);
end;

procedure ClearControls;
begin
	edit_login := '';
	edit_pass := '';
	edit_mail := '';
	edit_hostname := '';
	edit_replayname := '';
	edit_focused := 0;
	spawning := 0;
	online_selected_serv := 0;
	online_selected_serv_setting := 0;
	chatroom_show := false;
end;

procedure NetCancel;
begin	
	spawning := 0;
	edit_focused := 0;
	chat_msg := '';
end;

procedure Menu_Init;	// called once by engine.
begin
	ImageLoadAuto(0, ROOTDIR+'gui\gamelogo.tga');
	ImageLoadPat(1, ROOTDIR+'gui\cursors.tga', 32,32,128,128);
	ImageLoadPat(2, ROOTDIR+'gui\loading.tga', 32,32,128,128);
	ImageLoadAuto(3, ROOTDIR+'gui\menu_login.tga');
	ImageLoadAuto(4, ROOTDIR+'gui\menu_register.tga');
	ImageLoadAuto(5, ROOTDIR+'gui\menu_message.tga');
	ImageLoadAuto(6, ROOTDIR+'gui\menu_messageOK.tga');
	ImageLoadAuto(7, ROOTDIR+'gui\menu_onlineChannel.tga');
	ImageLoadAuto(8, ROOTDIR+'gui\menu_onlineServerList.tga');
	ImageLoadAuto(9, ROOTDIR+'gui\menu_onlineServerCreate.tga');
	ImageLoadAuto(10, ROOTDIR+'gui\menu_onlineStats.tga');
	ImageLoadAuto(11, ROOTDIR+'gui\menu_onlineServer.tga');
	ImageLoadAuto(12, ROOTDIR+'gui\menu_onlineServerTeam.tga');
	ImageLoadPat(13, ROOTDIR+'gui\awards.tga', 16,16,32,32);
	ImageLoadAuto(14, ROOTDIR+'gui\menu_onlineStatsRep.tga');

	curX := -100;
	curY := -100;
//	hangup_controls := false;
	assert_text := ''; // if not null then showbox
	assert_need_ok := true;
	chatroom_show := false;
	menu_item := 0;
	loading_pat := 0;
	SetMenuPage(1); //1-main; 0-none
	online_page := 1;
	chat_msg := '';
	spawning := 0;
	opt_page := 0;
	replay_avail := false;
	online := false;
	isServer  := false;
	remember_password := False;
	mn14 := GetTranslation('mn14');
	ClearControls;
	CPrint('Menu initialized.');
	//menu_page := 6; online_page := 3;

	hot_topic := '';
	hot_url   := '';
end;

procedure SetReplayName(s : string);
begin
	edit_replayname := s;
end;

procedure Menu_Operation(s : string);
begin
	assert_text := s; 
	assert_need_ok := False;
end;

procedure Menu_Result(s : string);
begin
	assert_text := s; 
	assert_need_ok := True;
end;

procedure Menu_NetworkEvent(Event : integer; Par : Integer);
begin
//	cprint('event received! '+inttostr(event)+' par:' +inttostr(par));
//	assert_need_ok := true;
//	assert_text := '';

	case event of
	  EVENT_CONNECTED : begin SetMenuPage(3); assert_text := ''; chatroom_show := true; end;
	  EVENT_DISCONNECTED : begin SetMenuPage(1); online := false; NetCancel; end;
	  EVENT_SERVERCREATED : begin assert_text := ''; chatroom_show := true; isServer  := true; SetMenuPage(3); end;
	  EVENT_SERVERCLOSED : begin isServer  := false; chatroom_show := false; if online then SetMenuPage(6) else SetMenuPage(1) online_page := 1; NetCancel; end; 
//	  EVENT_CLIENT_DISCONNECTED : begin assert_text := GetTranslation('mn13');  assert_need_ok := true; SetMenuPage(1); end;
	  EVENT_SPAWNING : begin spawning := 1; end;
	  EVENT_BNET_CONNECTED : begin SetMenuPage(4); edit_focused := 1; assert_text := ''; online := true; edit_login := GetVariable('cl_lastlogin'); edit_pass := GetVariable('cl_lastpass'); if edit_pass = '_none_' then edit_pass :=''; remember_password := edit_pass <> ''; end;
	  EVENT_CONNECTION_CANCELED : begin assert_need_ok := true; assert_text := GetTranslation('mn59');  SetMenuPage(1); end;
	  EVENT_LOGINRESULT : begin
		SetMenuPage(1);
		assert_need_ok := true;

		if par > LOGIN_BANNED then par := LOGIN_INVALID_VERSION;

		case Par of
		 LOGIN_SUCCEED : begin
			assert_text := '';
			SetMenuPage(6);
			online_page := 1;
			cmd('cl_lastlogin '+edit_login);
			if remember_password then
				cmd('cl_lastpass '+edit_pass)
			else 
				cmd('cl_lastpass _none_');
		end;
		 LOGIN_INVALID_STRING  : assert_text := GetTranslation('mn23'); 
		 LOGIN_INVALID_PASSWORD  : assert_text := GetTranslation('mn24'); 
		 LOGIN_INTERNAL_ERROR  : assert_text := GetTranslation('mn25'); 
		 LOGIN_ALREADY_LOGGED  : assert_text := GetTranslation('mn26'); 
		 LOGIN_INVALID_VERSION :  assert_text := GetTranslation('mn62'); 
		 LOGIN_BANNED  : assert_text := GetTranslation('mn70'); 
		end;
		
	end;
	  EVENT_REGISTERRESULT : begin
		SetMenuPage(1);
		assert_need_ok := true;
		case Par of
		 REGISTER_SUCCEED : begin assert_text := GetTranslation('mn37'); SetMenuPage(4); end;
		 REGISTER_INVALID_STRING  : assert_text := GetTranslation('mn23'); 
		 REGISTER_INVALID_EMAIL  : assert_text := GetTranslation('mn27'); 
		 REGISTER_INTERNAL_ERROR  : assert_text := GetTranslation('mn25'); 
		 REGISTER_ACCOUNT_EXISTS  : assert_text := GetTranslation('mn28'); 
		end;
	  end;
	  EVENT_VIRTUAL_CONNECT_RESULT, EVENT_LOCAL_CONNECT_RESULT : begin		
		assert_need_ok := true;
		online_page := 1;
		case Par of		
//		  CONNECT_SUCCEED 
	 	 CONNECT_NO_SERVER : assert_text := GetTranslation('mn29'); 
	 	 CONNECT_MAXPLAYERS : assert_text := GetTranslation('mn30'); 
		 CONNECT_LOCKED  : assert_text := GetTranslation('mn31'); 
		end;
	  end;
 	  EVENT_SHOW_STATS : begin
		  SetMenuPage(7);
		  replay_avail := true;
		end;
	  EVENT_VIRTUAL_DISCONNECT : begin
		chatroom_show := false;
		NetCancel;
		if online then begin SetMenuPage(6); online_page := 1; end;
	  end;
	  EVENT_STARTSERVER_ERROR : begin
		assert_need_ok := true;
		case Par of
		  CREATESERVER_INVALID_DATA : assert_text := GetTranslation('mn10');
		  CREATESERVER_BLOCKED : assert_text := GetTranslation('mn69');
		end;
	  end;

	end;
end;

// -----------------------------------------------------------------------------------------------
procedure Menu_page_do_click(item : byte);
begin	
	case item of
	0 : begin	
		cmd('connect nudl.net');
		SetMenuPage(0);
	    end;
	1 : begin
		SetMenuPage(6);
		cmd('enterlocalgame');
		online_selected_serv := 0;
		cmd('serverlist'); 
		online_page := 2;
//		if not isServer then cmd('listen 1');
	     end;
		
	2 : begin SetMenuPage(PAGE_REPLAYS); end;
	3 : begin SetMenuPage(2); opt_page := 0; end;
//	4 : begin SetMenuPage(PAGE_AUTHORS); end;
	4 : cmd('quit');
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure GetWHforMon(i : integer; var ww,hh : integer);
begin
	case opt_selected_monitor of
	0, 1 :	// 4:3	
		case i of
		 0 : begin ww := 640; hh := 480; end;
	 	 1 : begin ww := 800; hh := 600; end;
	 	 2 : begin ww := 1024; hh := 768; end;
		end;
	2 : 	// 16:9
		case i of
		 0 : begin ww := 853; hh := 480; end;
	 	 1 : begin ww := 1067; hh := 600; end;
	 	 2 : begin ww := 1366; hh := 768; end;
		end;
	3:	// 16:10
		case i of
		 0 : begin ww := 768; hh := 480; end;
	 	 1 : begin ww := 960; hh := 600; end;
	 	 2 : begin ww := 1280; hh := 800; end;
		end;
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure OptionsPageDoClick(item : byte);
var	w, h, i : integer;
begin
	case item of
		1 : begin
			opt_page := 1;
			opt_video_changes := false;
			opt_selected_monitor := strtoint(GetVariable('r_monitor'));
			opt_selected_mode := strtoint(GetVariable('r_fullscreen'));
			opt_video_w := strtoint(GetVariable('r_width'));
			opt_video_h := strtoint(GetVariable('r_height'));
			opt_selected_resolution := 255;
			for i:=0 to 2 do begin
				GetWHforMon(i,w,h);
				if (w=opt_video_w) and (h=opt_video_h) then begin
					opt_selected_resolution := i;
					break;
				end;
			end;
		    end;

		2 : SetMenuPage(1);
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_draw_assert;
begin
//	DrawRect(screen_w div 2 - screen_w div 4 , SCREEN_H div 2 - screen_h div 4, screen_w div 2, screen_h div 4, $77000000, blendSrcAlpha);

	if assert_need_ok then begin 
		DrawImage(6, SCREEN_W div 2 - 160, SCREEN_H div 2 - 50, 0, blendSrcAlpha);
		TextCenterOut(assert_text, SCREEN_W div 2, SCREEN_H div 2 - 16, $FFFFFFFF, False);
//		DrawRect(screen_w div 2 - 25, SCREEN_H div 2 + 10, 50, 18, $33FFFFFF, blendSrcAlpha);
		TextCenterOut('OK', screen_w div 2, SCREEN_H div 2 + 18, $FFFFFFFF, False);
	end else begin
		DrawImage(5, SCREEN_W div 2 - 160, SCREEN_H div 2 - 50, 0, blendSrcAlpha);
		TextCenterOut(assert_text, SCREEN_W div 2, SCREEN_H div 2 - 6, $FFFFFFFF, False);
	end;

	if assert_need_ok then begin
//		if CursorInRegion(screen_w div 2 - 50, SCREEN_H div 2 - screen_h div 10, 100, 18) then
//		DrawRect(screen_w div 2 - 50, SCREEN_H div 2 - screen_h div 10, 100, 18, $55FFFFFF, blendSrcAlpha) else
//		DrawRect(screen_w div 2 - 50, SCREEN_H div 2 - screen_h div 10, 100, 18, $33FFFFFF, blendSrcAlpha);
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_Draw_Bnet_Login;
var 	str : string;
	i : integer;
	ln : integer;
begin
	DrawImage(3, SCREEN_W div 2 - 74, SCREEN_H div 2 - 94, 0, blendSrcAlpha);

	TextOut(GetTranslation('mn15'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 + 4,  $FFFFFFFF, False);
	TextOut(GetTranslation('mn16'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 +29,  $FFB1EFDB, False);
	TextOut(GetTranslation('mn17'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 +70,  $FFB1EFDB, False);

	str := edit_login;
	LN := TextOutLimited(str, SCREEN_W div 2 - 74 + 14, SCREEN_H div 2 - 94 +47,  $FFFFFFFF, 115, False);
	if edit_focused = 1 then if CanBlink then TextOut('|', SCREEN_W div 2 - 74 + 14+LN, SCREEN_H div 2 - 94 +47,  $FFFFFFFF, False);

	str := edit_pass;
	if length(str) > 0 then for i := 1 to length(str) do str[i] := '*'; // mask
	ln := TextOutLimited(str, SCREEN_W div 2 - 74 + 14, SCREEN_H div 2 - 94 +89,  $FFFFFFFF, 115, False);
	if edit_focused = 2 then if CanBlink then TextOut('|', SCREEN_W div 2 - 74 + 14+LN, SCREEN_H div 2 - 94 +89,  $FFFFFFFF, False);

	TextOut(GetTranslation('mn74'), SCREEN_W div 2 - 74 + 28, SCREEN_H div 2 - 94 +114,  $FFB1EFDB, False);

	ln := 0;
	ln := TextOutWrapped( GetTranslation('mn75') , SCREEN_W div 4, SCREEN_H div 2 + 130, $FFCCCCCC, False, SCREEN_W div 2);
	TextOutWrapped( GetTranslation('mn76') , SCREEN_W div 4, SCREEN_H div 2 +  140 + LN, $FFCCCCCC, False, SCREEN_W div 2);

	TextCenterOut(GetTranslation('mn18'), SCREEN_W div 2 - 74 + 38, SCREEN_H div 2 - 94 +132 + 11,  $FFB1EFDB, False);
	TextCenterOut(GetTranslation('mn19'), SCREEN_W div 2 - 74 + 109, SCREEN_H div 2 - 94 +132 + 11,  $FFB1EFDB, False);
	TextCenterOut(GetTranslation('mn20'), SCREEN_W div 2 - 74 + 72, SCREEN_H div 2 - 94 +159 + 11,  $FFB1EFDB, False);

	if remember_password then DrawImage(13, SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 +114, 3, blendSrcAlpha);

//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +116, 124, 14, $33FFFFFF, blendSrcAlpha); // remember
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +47, 124, 18, $33FFFFFF, blendSrcAlpha); // Login
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +89, 124, 18, $33FFFFFF, blendSrcAlpha); // Pass
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +124, 55, 18, $33FFFFFF, blendSrcAlpha); // vhod
//	DrawRect(SCREEN_W div 2 - 74 + 12 + 69, SCREEN_H div 2 - 94 +124, 55, 18, $33FFFFFF, blendSrcAlpha); // Cancel
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +152, 124, 18, $33FFFFFF, blendSrcAlpha); // Register
//	TextCenterOut(assert_text, SCREEN_W div 2, SCREEN_H div 2 - screen_h div 6, $FFFFFFFF, False);
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_bnet_login_click;
begin
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +47, 124, 18) then edit_focused := 1; // login
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +89, 124, 18) then edit_focused := 2; // pass
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +116, 124, 14) then remember_password := not remember_password;
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +124 + 11, 55, 18) then if (edit_login <> '') and (edit_pass <> '') then cmd('login '+edit_login+' '+edit_pass); // login btn
	if CursorInRegion(SCREEN_W div 2 - 74 + 12 + 69, SCREEN_H div 2 - 94 +124 + 11, 55, 18) then cmd('disconnect');	// cancel btn
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +152 + 11, 124, 18) then begin SetMenuPage(5); edit_fosused := 1; end;		// register acc

end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_Draw_Bnet_Register;
var 	str : string;
	i : integer;
	LN : integer;
begin
	DrawImage(4, SCREEN_W div 2 - 74, SCREEN_H div 2 - 94, 0, blendSrcAlpha);

	TextOut(GetTranslation('mn20'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 + 4,  $FFFFFFFF, False);
	TextOut(GetTranslation('mn16'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 +29,  $FFB1EFDB, False);
	TextOut(GetTranslation('mn17'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 +70,  $FFB1EFDB, False);
	TextOut(GetTranslation('mn22'), SCREEN_W div 2 - 74 + 10, SCREEN_H div 2 - 94 +110,  $FFB1EFDB, False);

	str := edit_login;
	LN := TextOutLimited(str, SCREEN_W div 2 - 74 + 14, SCREEN_H div 2 - 94 +47,  $FFFFFFFF, 115, False);
	if edit_focused = 1 then if CanBlink then TextOut('|', SCREEN_W div 2 - 74 + 14+LN, SCREEN_H div 2 - 94 +47,  $FFFFFFFF, False);

	str := edit_pass;
	LN := TextOutLimited(str, SCREEN_W div 2 - 74 + 14, SCREEN_H div 2 - 94 +89,  $FFFFFFFF, 115, False);
	if edit_focused = 2 then if CanBlink then TextOut('|', SCREEN_W div 2 - 74 + 14+LN, SCREEN_H div 2 - 94 +89,  $FFFFFFFF, False);

	str := edit_mail;
	LN := TextOutLimited(str, SCREEN_W div 2 - 74 + 14, SCREEN_H div 2 - 94 +131,  $FFFFFFFF, 115, False);
	if edit_focused = 3 then if CanBlink then TextOut('|', SCREEN_W div 2 - 74 + 14+LN, SCREEN_H div 2 - 94 +131,  $FFFFFFFF, False);

	TextCenterOut(GetTranslation('mn21'), SCREEN_W div 2 - 74 + 38, SCREEN_H div 2 - 94 +132 + 42,  $FFB1EFDB, False);
	TextCenterOut(GetTranslation('mn19'), SCREEN_W div 2 - 74 + 109, SCREEN_H div 2 - 94 +132 + 42,  $FFB1EFDB, False);

//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +47, 124, 18, $33FFFFFF, blendSrcAlpha); // edit1
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +89, 124, 18, $33FFFFFF, blendSrcAlpha); // edit2
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +131, 124, 18, $33FFFFFF, blendSrcAlpha); // edit3
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +124 + 43, 55, 18, $33FFFFFF, blendSrcAlpha); // OK
//	DrawRect(SCREEN_W div 2 - 74 + 12 + 69, SCREEN_H div 2 - 94 +124 + 43, 55, 18, $33FFFFFF, blendSrcAlpha); // Cancel
//	DrawRect(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +152, 124, 18, $33FFFFFF, blendSrcAlpha); // Register
//	TextCenterOut(assert_text, SCREEN_W div 2, SCREEN_H div 2 - screen_h div 6, $FFFFFFFF, False);
	
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_bnet_register_click;
begin
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +47, 124, 18) then edit_focused := 1; // login
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +89, 124, 18) then edit_focused := 2; // pass
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +131, 124, 18) then edit_focused := 3; // mail
	if CursorInRegion(SCREEN_W div 2 - 74 + 12, SCREEN_H div 2 - 94 +124 + 43, 55, 18) then if (edit_login <> '') and (edit_pass <> '') and (edit_mail <> '')  then cmd('register '+edit_login+' '+edit_pass+' '+edit_mail); // register btn
	if CursorInRegion(SCREEN_W div 2 - 74 + 12 + 69, SCREEN_H div 2 - 94 +124 + 43, 55, 18) then begin SetMenuPage(4); edit_fosused := 1; end;	// cancel btn
end;

// -----------------------------------------------------------------------------------------------
procedure DrawBlock(x,y, pos, val : integer);
var i : integer;
begin
	for i := 3 to pos do 	
		if i < pos then 
			DrawImage(13, x+i*8, y, 0 , blendSrcAlpha);
		else begin		
			DrawImage(13, x+i*8, y, val , blendSrcAlpha);
			exit;
		end;
end;

// -----------------------------------------------------------------------------------------------
procedure DrawAward(x, y : integer; level : byte);
var i : integer;
	left : integer;
	
begin
	left := 100;
	if level > left then exit;

	left := left - level;

	for i := 0 to 2 do begin
		if left > 33 then
			DrawImage(13, x+i*8, y, 0 , blendSrcAlpha)
		else
			DrawImage(13, x+i*8, y, 2 - left div 11, blendSrcAlpha)
		left := left - 33;
		if left < 0 then break;
	end;

	if level <= 11 then
	case level of
	  11 : DrawBlock(x,y,3, 2);
	  10 : DrawBlock(x,y,3, 1);
	  9 : DrawBlock(x,y,3, 0);
	  8 : DrawBlock(x,y,4, 2);
	  7 : DrawBlock(x,y,4, 1);
	  6 : DrawBlock(x,y,4, 0);
	  5 : DrawBlock(x,y,5, 2);
	  4 : DrawBlock(x,y,5, 1);
	  3 : DrawBlock(x,y,5, 0);
	  2 : DrawBlock(x,y,6, 2);
	  1 : DrawBlock(x,y,6, 1);
	  0 : DrawBlock(x,y,6, 0);
	end;
	
//	TextOut(inttostr(level) , x+ 150, y, $FFFFFFFF, False);
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_Draw_Bnet_Room;
var	i : integer;
	str, str2 : string;
	color : integer;
	hg : integer;
	rtop, rleft : integer;
	ln : integer;
begin
	rleft := SCREEN_W div 2 - 256;
	rtop := SCREEN_H div 2 - 128;

	case online_page of
		1 : DrawImage(7, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha);
		2 : DrawImage(8, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha);
		3 : DrawImage(9, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha);
		4 : DrawImage(7, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha);
	end;

	for i := 0 to 3 do begin
		if (not online) and (i=0) then continue;
		if online_page = i+1 then DrawRect(rleft + 8, rtop + 12+20*i, 86, 14, $33B1EFDB, blendSrcAlpha); // edit1
		if (CursorInRegion(SCREEN_W div 2 - 256 + 8, SCREEN_H div 2 - 128 + 12+20*i, 86, 14)) or (i+1=online_page) then
		TextOut(GetTranslation('mn'+inttostr(38+i)), SCREEN_W div 2 - 256 + 10, SCREEN_H div 2 - 128 + 10 + 20*i,  $FFFFFFFF, False) else
		TextOut(GetTranslation('mn'+inttostr(38+i)), SCREEN_W div 2 - 256 + 10, SCREEN_H div 2 - 128 + 10 + 20*i,  $FFB1EFDB, False);
	end;

//	DrawRect(SCREEN_W div 2 - 256 + 8, SCREEN_H div 2 - 128 + 12+18*1, 86, 14, $33B1EFDB, blendSrcAlpha); // online menu rect

//	TextCenterOut('You are ONLINE|Create srv', SCREEN_W div 2, SCREEN_H div 2 - screen_h div 6, $FFFFFFFF, False);

	// lobby room
	if online_page = 1 then begin
		LN := TextOutLimited( chat_msg , rleft  + 105, rtop + 12+278, $FFFFFFFF, 318, False);
		if CanBlink then TextOut('|', rleft  + 105+ LN, rtop + 12+278,  $FFFFFFFF, False);

//		if chat_msg <> '' then
		TextCenterOut(GetTranslation('mn45'), SCREEN_W div 2 - 256 + 468, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False);// else
//		TextCenterOut(GetTranslation('mn45'), SCREEN_W div 2 - 256 + 468, SCREEN_H div 2 - 128 + 12+285,  $aaaaaaaa, False);

		hg := 0;
		if room_lobbymsgcount > 0 then
		for i := 0 to room_lobbymsgcount - 1  do begin
			if rtop + 260 - hg + 16 <= rtop + 20 then break;
			hg := hg + TextOutWrappedGetHeight(room_getlobbymsg(i), False, 370);
			TextOutWrapped( room_getlobbymsg(i) , rleft +108, rtop + 260 - hg + 16, $FFFFFFFF, False, 370);
		end;
	end;


	// serverlist
	if online_page = 2 then begin

	//	TextOut('servers :'+ inttostr(room_serverscount) , SCREEN_W div 2 - 256 + 100, SCREEN_H div 2 - 128  , $FF00FFFF, False);	
		TextOut(GetTranslation('mn42') , SCREEN_W div 2 - 256 + 110, SCREEN_H div 2 - 128 + 10, $CCFFFFFF, True);	
		TextOut(GetTranslation('mn44') , SCREEN_W div 2 - 256 + 270, SCREEN_H div 2 - 128 + 10, $CCFFFFFF, True);
		TextOut(GetTranslation('mn55') , SCREEN_W div 2 - 256 + 350, SCREEN_H div 2 - 128 + 10, $CCFFFFFF, True);
		TextOut(GetTranslation('mn43') , SCREEN_W div 2 - 256 + 435, SCREEN_H div 2 - 128 + 10, $CCFFFFFF, True);

		if room_serverscount > 0 then
		for i:=0 to room_serverscount - 1 do begin
			if i+1=online_selected_serv then
			DrawRect(SCREEN_W div 2 - 256 + 105, SCREEN_H div 2 - 128 + 30 + 18*i, 386, 18, $33B1EFDB, blendSrcAlpha); 
			
			color  := $FFB1EFDB;
			if room_getserver(i,5) = '1' then color := $cccccccc; // LOCKED!
			TextOut(room_getserver(i,1) , SCREEN_W div 2 - 256 + 110, SCREEN_H div 2 - 128 + 30 + 18*i, color , False);	
			TextOut(GetTranslation('gm0'+room_getserver(i,4)), SCREEN_W div 2 - 256 + 270, SCREEN_H div 2 - 128 + 30 + 18*i, color , False);	
			TextOut(room_getserver(i,3)+'/'+room_getserver(i,2) , SCREEN_W div 2 - 256 + 440, SCREEN_H div 2 - 128 + 30 + 18*i, color, False);
			TextOut(room_getserver(i,6) , SCREEN_W div 2 - 256 + 355, SCREEN_H div 2 - 128 + 30 + 18*i, color , False);
		end;

		if room_serverlistisupdating then
		TextCenterOut(GetTranslation('mn47'), SCREEN_W div 2 - 256 + 134, SCREEN_H div 2 - 128 + 12+285,  $aaaaaaaa, False) else
		TextCenterOut(GetTranslation('mn47'), SCREEN_W div 2 - 256 + 134, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False);

		if online_selected_serv > 0 then
		TextCenterOut(GetTranslation('mn18'), SCREEN_W div 2 - 256 + 468, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False) else
		TextCenterOut(GetTranslation('mn18'), SCREEN_W div 2 - 256 + 468, SCREEN_H div 2 - 128 + 12+285,  $aaaaaaaa, False);
		// DrawRect(SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 12+278, 65, 18, $33B1EFDB, blendSrcAlpha); // REFRESH

	end;

	// create server
	if online_page = 3 then begin
		if online then
			TextOut(GetTranslation('mn48') , SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 6, $CCFFFFFF, True)
		else
			TextOut(GetTranslation('mn49') , SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 6, $CCFFFFFF, True);	
		TextOut(GetTranslation('mn50')  , SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 25, $FFB1EFDB, False);	
		TextOut(GetTranslation('mn56')  , SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 70, $FFB1EFDB, False);	 // serverparameters

		str := edit_hostname;
		if edit_focused = 1 then str := str+ '|';

		TextOut(str , SCREEN_W div 2 - 256 + 106, SCREEN_H div 2 - 128 + 45, $FFFFFFFF, False);	
		TextOut(GetTranslation('mn51') , SCREEN_W div 2 - 256 + 110, SCREEN_H div 2 - 128 + 93, $CCFFFFFF, True);	
		TextOut(GetTranslation('mn52') , SCREEN_W div 2 - 256 + 300, SCREEN_H div 2 - 128 + 93, $CCFFFFFF, True);

		TextCenterOut(GetTranslation('mn53'), SCREEN_W div 2 - 256 + 468, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False); // Create

		// print out settings
		
		for i:=0 to 2 do begin
			if i+1=online_selected_serv_setting then
			DrawRect(SCREEN_W div 2 - 256 + 105, SCREEN_H div 2 - 128 + 112 + 18*i, 386, 14, $33B1EFDB, blendSrcAlpha); 
			
			case i of 
			0 : begin str := GetTranslation('gm10'); str2 := GetTranslation('gm0'+GetVariable('sv_gametype'));  end;
			1 : begin str := GetTranslation('mn08'); str2 := GetVariable('sv_players');  end;
			2 : begin str := GetTranslation('mn61'); str2 := GetVariable('sv_timeperturn');  end;
			end;

			TextOut(str , SCREEN_W div 2 - 256 + 110, SCREEN_H div 2 - 128 + 110 + 18*i, $FFB1EFDB, False);	
			if CursorInRegion(SCREEN_W div 2 - 256 + 305, SCREEN_H div 2 - 128 + 110 + 18*i, 186, 18) then
				TextOut(str2, SCREEN_W div 2 - 256 + 310, SCREEN_H div 2 - 128 + 110 + 18*i, $FFFFFFFF, False) else
			TextOut(str2, SCREEN_W div 2 - 256 + 310, SCREEN_H div 2 - 128 + 110 + 18*i, $FFB1EFDB, False);
		end;

//		DrawRect(SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 46, 290, 18, $33B1EFDB, blendSrcAlpha); // sv_hostname edit
	end;

	if online then 
	if (online_page >= 1) and (online_page <= 3) then begin
		TextOut(GetTranslation('mn43') , SCREEN_W div 2 - 256 + 510, SCREEN_H div 2 - 128, $FFFFFFFF, True);

		// userlist
		if room_buserscount > 0 then
		for i:=0 to room_buserscount - 1 do begin
//			if i+1=online_selected_serv then
//			DrawRect(SCREEN_W div 2 - 256 + 105, SCREEN_H div 2 - 128 + 30 + 18*i, 386, 18, $33B1EFDB, blendSrcAlpha); 
			TextOut(room_getbuser(i,1), SCREEN_W div 2 - 256 + 510, SCREEN_H div 2 - 128 + 16 + 14*i, $FFB1EFDB, False);
			DrawAward( rleft + 510 + TextWidth(room_getbuser(i,1), False) , rtop + 16 + 14*i, strtoint(room_getbuser(i,2)) );
		end;
	end;


//	DrawRect(SCREEN_W div 2 - 256 + 440, SCREEN_H div 2 - 128 + 12+278, 55, 18, $33B1EFDB, blendSrcAlpha); // SEND
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_bnet_Room_click;
var i, pl : integer;
begin
	for i := 0 to 3 do
	if CursorInRegion(SCREEN_W div 2 - 256 + 8, SCREEN_H div 2 - 128 + 12+20*i, 86, 14) then
	case i of
		0 : if online then online_page := 1;
		1 : if online_page <> 2 then begin online_selected_serv := 0;  cmd('serverlist'); online_page := 2; end;
		2 : begin edit_hostname := GetVariable('sv_hostname'); online_page := 3; end;
		3 : if online then cmd('disconnect') else SetMenuPage(1);
	end;

	if CursorInRegion(SCREEN_W div 2 - 256 + 440, SCREEN_H div 2 - 128 + 12+278, 55, 18) then 
	if online_page = 1 then 
	if chat_msg > '' then begin
		cmd('bsay '+chat_msg);
		chat_msg := '';
	end;

	if online_page = 2 then begin
		if room_serverscount > 0 then begin
			for i:=0 to room_serverscount - 1 do // select serv
			if CursorInRegion(SCREEN_W div 2 - 256 + 105, SCREEN_H div 2 - 128 + 30 + 18*i, 386, 18) then online_selected_serv := i+1;
			if CursorInRegion(SCREEN_W div 2 - 256 + 440, SCREEN_H div 2 - 128 + 12+278, 55, 18) then if online_selected_serv > 0 then if room_serverscount >= online_selected_serv then
			begin // connect to srv
				if online then
					cmd('connect '+room_getserver(online_selected_serv-1,0))
				else
					cmd('connect '+room_getserver(online_selected_serv-1,7)); //lan
			end;
		end;
		if CursorInRegion(SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 12+278, 65, 18) then begin online_selected_serv := 0; cmd('serverlist'); end;
	end;

	if online_page = 3 then begin

		if CursorInRegion(SCREEN_W div 2 - 256 + 102, SCREEN_H div 2 - 128 + 46, 290, 18) then begin
			edit_focused := 1;
			online_selected_serv_setting := 0;
		end;

		if CursorInRegion(SCREEN_W div 2 - 256 + 440, SCREEN_H div 2 - 128 + 12+278, 55, 18) then begin
			cmd('sv_hostname '+edit_hostname);
			if not isServer then cmd('listen 1');
		end;

		for i:=0 to 10 do begin// select serv setting		
			// cycle settings
			if online_selected_serv_setting = i+1 then
			if CursorInRegion(SCREEN_W div 2 - 256 + 305, SCREEN_H div 2 - 128 + 110 + 18*i, 186, 18) then
			case online_selected_serv_setting of
			1 : begin
				pl := strtoint(GetVariable('sv_gametype'));
				inc(pl); 
				if pl > 1 then pl := 0;
				cmd('sv_gametype '+inttostr(pl));
				if pl > 0 then if GetVariable('sv_players') <> '4' then
					cmd('sv_players 4');
			     end;
			2 : begin
				pl := strtoint(GetVariable('sv_players'));
				inc(pl); 
				if pl > 4 then pl := 2;
				cmd('sv_players '+inttostr(pl));
			     end;
			3 : begin
				pl := strtoint(GetVariable('sv_timeperturn'));
				pl := pl + 20; 
				if pl > 180 then pl := 60;
				cmd('sv_timeperturn '+inttostr(pl));
			     end;
			end;

			// select setting
			if CursorInRegion(SCREEN_W div 2 - 256 + 105, SCREEN_H div 2 - 128 + 110 + 18*i, 386, 18) then begin
				online_selected_serv_setting := i+1;
				edit_focused := 0;
			end;
		end;
	end;

end;

// -----------------------------------------------------------------------------------------------
procedure Menu_page_Draw_Stats;
var	i : integer;
	str, str2 : string;
	ln : integer;
begin
	if (replay_avail) then
	DrawImage(14, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha) else
	DrawImage(10, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha);

	if room_statscount > 0 then
	for i:=0 to room_statscount - 1 do begin
		TextOut(room_getstats(i) , SCREEN_W div 2 - 256 + 50, SCREEN_H div 2 - 128 + 30 + 18*i, $FFB1EFDB, i=0);
	end;

	if (replay_avail) then begin
		TextOut(GetTranslation('mn89')  , SCREEN_W div 2 - 256 + 12, SCREEN_H div 2 + 114, $FFB1EFDB, False);	

		str := edit_replayname;
		LN := TextOutLimited(str, SCREEN_W div 2 - 256 + 14, SCREEN_H div 2 + 135,  $FFFFFFFF, 406, False);
		if edit_focused = 1 then if CanBlink then TextOut('|', SCREEN_W div 2 - 256 + 14+LN, SCREEN_H div 2 +135,  $FFFFFFFF, False);

		TextCenterOut(GetTranslation('mn88'), SCREEN_W div 2 - 256 + 44, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False);
	//	DrawRect(SCREEN_W div 2 - 256 + 10, SCREEN_H div 2 + 134, 328, 18, $33B1EFDB, blendSrcAlpha); 
	//	DrawRect(SCREEN_W div 2 - 256 + 10, SCREEN_H div 2 + 163, 70, 18, $33B1EFDB, blendSrcAlpha); 
	end;

	TextCenterOut(GetTranslation('mn21'), SCREEN_W div 2 - 256 + 468, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False);
end;

// -----------------------------------------------------------------------------------------------
procedure Menu_page_Stats_click;
var i, pl : integer;
begin
	if replay_avail then begin
		if CursorInRegion(SCREEN_W div 2 - 256 + 10, SCREEN_H div 2 + 134, 416, 18) then // edit
			edit_focused := 1;

		if CursorInRegion(SCREEN_W div 2 - 256 + 10, SCREEN_H div 2 + 163, 70, 18) then begin// save btn
			cmd('savereplay '+edit_replayname);
			replay_avail := false;
		end;
	end;

	if CursorInRegion(SCREEN_W div 2 - 256 + 440, SCREEN_H div 2 - 128 + 12+278, 55, 18) then begin
		replay_avail := false;
		online_page := 1;
		if online then
		SetMenuPage(6) else
		SetMenuPage(1);
	end;
end;
	
// -----------------------------------------------------------------------------------------------

procedure Menu_page_draw_ServerRoom;
var 	rleft, rtop, i, hg, ln : integer;
	color : integer;
begin
	if teamgame then
	DrawImage(12, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha) else
	DrawImage(11, SCREEN_W div 2 - 256, SCREEN_H div 2 - 128, 0, blendSrcAlpha);


	rleft := SCREEN_W div 2 - 256;
	rtop := SCREEN_H div 2 - 128;

//	DrawRect(rleft , rtop, 200, 100, $77000000, blendSrcAlpha);
//	DrawRect(screen_w - 150 - rleft  , rtop, 200, 100, $77000000, blendSrcAlpha);
	TextOut(GetTranslation('mn12'), rleft + 12, rtop + 10, $FFFFFFFF, False);

	if isServer then
	TextOut(inttostr(room_playerscount) +' / ' + GetVariable('sv_players'), rleft + 12 + 482 - TextWidth(inttostr(room_playerscount) +' / ' + GetVariable('sv_players'), False), rtop + 10, $CCFFFFFF, False);
	TextCenterOut(GetTranslation('mn45'), SCREEN_W div 2 - 256 + 287, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False); // say

	if teamgame then begin
		TextOut(GetTranslation('gm11'), rleft + 12 + 310, rtop + 32, $CCFFFFFF, True);
		TextOut(GetTranslation('gm12'), rleft + 12 + 310, rtop + 139, $CCFFFFFF, True);
	end;

	if (isServer) and ( (online=false) or ((room_playerscount > 1) or ((teamgame) and (room_playerscount >= 4))  ) ) then
	
	TextCenterOut(GetTranslation('mn64'), SCREEN_W div 2 - 256 + 459, SCREEN_H div 2 - 128 + 270,  $FFB1EFDB, False) else	// go
	TextCenterOut(GetTranslation('mn64'), SCREEN_W div 2 - 256 + 459, SCREEN_H div 2 - 128 + 270,  $aaaaaaaa, False);	// go

	if room_playerscount > 0 then
	TextCenterOut(GetTranslation('mn65'), SCREEN_W div 2 - 256 + 459, SCREEN_H div 2 - 128 + 12+285,  $FFB1EFDB, False) else // close
	TextCenterOut(GetTranslation('mn65'), SCREEN_W div 2 - 256 + 459, SCREEN_H div 2 - 128 + 12+285,  $aaaaaaaa, False); // close

//	DrawRect(rleft + 424, rtop + 11+280, 70 , 18 , $22B1EFDB, blendSrcAlpha);
//	DrawRect(rleft + 424, rtop + 11+252, 70 , 18 , $22B1EFDB, blendSrcAlpha);
//	DrawRect(rleft + 260, rtop + 11+280, 55 , 18 , $22B1EFDB, blendSrcAlpha); // say



///	if not chatroom_show then

//	TextOut(GetTranslation('mn08')+GetVariable('sv_players'), rleft + 20, rtop + 20, $FFB1EFDB, False);

//	if CursorInRegion(128 + 15, 128 + 20 * 3, 100, 15) then // start serv btn
//	DrawRect(rleft + 15, rtop + 20*3, 100, 18, $55FFFFFF, blendSrcAlpha) else
//	DrawRect(rleft + 15, rtop + 20*3, 100, 18, $33FFFFFF, blendSrcAlpha);
//	if chatroom_show then
//	TextCenterOut(GetTranslation('mn11'), rleft + 50+15, rtop + 20*3 + 7, $FFB1EFDB, False) else
//	TextCenterOut(GetTranslation('mn06'), rleft + 50+15, rtop + 20*3 + 7, $FFB1EFDB, False);

	if chatroom_show then begin
//		DrawRect(rleft , rtop + 120, screen_w - rleft *2 , screen_h -  rtop - 140 , $77000000, blendSrcAlpha);

		hg := 0;

		if room_msgcount > 0 then
		for i:=0 to room_msgcount - 1 do begin
			if rtop + 260 - hg + 16 < rtop + 40 then break;
			hg := hg + TextOutWrappedGetHeight(room_getmsg(i), False, 285);
			TextOutWrapped( room_getmsg(i) , rleft +16, rtop + 260 - hg + 16, $FFFFFFFF, False, 285);

		end;

		if teamgame = false then
		if room_playerscount > 0 then
		for i:=0 to room_playerscount - 1 do begin
			TextOut( room_getplayer(i,0) , rleft+328, rtop + 34 + i*28, $FFB1EFDB, False);	
			DrawAward( rleft + 328+ TextWidth(room_getplayer(i,0), False) , rtop + 34 + i*28+1, strtoint(room_getplayer(i,2)) );

		end;

		if teamgame = true then begin
			ln := 0;
			if room_playerscount > 0 then
			for i:=0 to room_playerscount - 1 do
			if room_getplayer(i,1) = 0 then begin// team1

				if  CursorInRegion(rleft+328, rtop + 50 + ln*23, 130 , 18) then color := $FFFFFFFF else
				color := $FFB1EFDB;
				TextOut( room_getplayer(i,0) , rleft+328, rtop + 50 + ln*23, color , False);
				DrawAward( rleft + 328+ TextWidth(room_getplayer(i,0), False) , rtop + 50 + ln*23+1, strtoint(room_getplayer(i,2)) );
				inc(ln);
			end;
			
			ln := 0;
			if room_playerscount > 0 then
			for i:=0 to room_playerscount - 1 do
			if room_getplayer(i,1) = 1 then begin// team1

				if  CursorInRegion(rleft+328, rtop + 157 + ln*23, 130 , 18) then color := $FFFFFFFF else
				color := $FFB1EFDB;
				TextOut( room_getplayer(i,0) , rleft+328, rtop + 157 + ln*23, color, False);
				DrawAward( rleft + 328+ TextWidth(room_getplayer(i,0), False) , rtop + 157 + ln*23+1, strtoint(room_getplayer(i,2)) );
				inc(ln);
			end;
			
		end;

//		DrawRect(rleft, screen_h -  35, screen_w - rleft *2 , 15 , $22B1EFDB, blendSrcAlpha);

		LN := TextOutLimited( chat_msg , rleft + 16, rtop + 290, $FFB1EFDB, 227, False);
		if CanBlink then TextOut('|', rleft + 16+LN, rtop + 290,  $FFFFFFFF, False);

//		if isServer then begin
//			if  CursorInRegion(screen_w - 75, screen_h - 75, 32,32) then
//			DrawImage(1, screen_w - 75, screen_h - 75, 5, blendAdd) else
//			DrawImage(1, screen_w - 75, screen_h - 75, 5, blendSrcAlpha);
//		end;
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_Page_ServerRoom_Click;
var rleft, rtop, i : integer;
var pl : byte;
	ln : integer;

begin
	rleft := SCREEN_W div 2 - 256;
	rtop := SCREEN_H div 2 - 128;

//	if CursorInRegion(128, 128 + 20 * 1, 180, 15) then begin // click players
//		pl := strtoint(GetVariable('sv_players'));
//		inc(pl); 
//		if pl > 4 then pl := 2;
//		cmd('sv_players '+inttostr(pl));
//	end;

//	if (room_playerscount > 1) or (not online)  then
//	if CursorInRegion(rleft + 424, rtop + 11+252, 70 , 18 ) then begin // start serv
//		hangup_controls := true;
//		assert_need_ok := false;
//		cprint('creating server');
//		assert_text := 'a'+ GetTranslation('mn09');
//		if not isServer then cmd('listen 1') else cmd('listen 0');
//	end;
	
	if ( (online=false) or ((room_playerscount > 1) or ((teamgame) and (room_playerscount >= 4))  ) ) then
	if chatroom_show then 
	if isServer then
	if  CursorInRegion(rleft + 424, rtop + 11+252, 70 , 18) then begin
		chat_msg := '';
		cmd('server_spawn');
	end;

	// close server
	if (room_playerscount > 0) then
	if  CursorInRegion(rleft + 424, rtop + 11+280, 70 , 18) then begin
		if isServer then begin			
			cmd('listen 0');
		end else
			if online then cmd('bpartserver') else cmd('disconnect');
	end;
	
	// say
	if (room_playerscount > 0) then
	if  CursorInRegion(rleft + 260, rtop + 11+280, 55 , 18) then begin
		cmd('say '+chat_msg);
		chat_msg := '';
	end;	

	// toggleplayer team
	if teamgame = true then begin
		ln := 0;
		if room_playerscount > 0 then
		for i:=0 to room_playerscount - 1 do
		if room_getplayer(i,1) = 0 then begin
			if  CursorInRegion(rleft+328, rtop + 50 + ln*23, 130 , 18) then cmd('toggleteam '+room_getplayer(i,0));
			inc(ln);
		end;
			
		ln := 0;
		if room_playerscount > 0 then
		for i:=0 to room_playerscount - 1 do
		if room_getplayer(i,1) = 1 then begin// team1
			if  CursorInRegion(rleft+328, rtop + 157 + ln*23, 130 , 18) then cmd('toggleteam '+room_getplayer(i,0));
			inc(ln);
		end;		
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_Options_Draw_Video;
var maxw : integer;
	shiftx : integer;
	topy : integer;
	res : string;
	ww, hh : integer;
begin
//	opt_selected_monitor : byte;
//	opt_selected_videomode : byte;
//	opt_selected_resolution : byte;
	shiftx := -60;

	topy := SCREEN_H div 3;

	TextCenterOut(GetTranslation('op09'), SCREEN_W div 2, topy - 20, $FFFFFFFF, False);

	// monitor
	TextOut(GetTranslation('op01'), SCREEN_W div 2 - TextWidth(GetTranslation('op01'),True) - 5 + shiftx , topy, $FFB1EFDB, True);

	maxw := 0;
	for i := 0 to 3 do begin
		if TextWidth(GetTranslation('op0'+inttostr(i+2)),False) > maxw then
			maxw := TextWidth(GetTranslation('op0'+inttostr(i+2)),False);

		if opt_selected_monitor = i then
		DrawRect(SCREEN_W div 2-3 + shiftx, topy + 15*i + 2, maxw+6, 14, $33B1EFDB, blendSrcAlpha); 
		TextOut(GetTranslation('op0'+inttostr(i+2)), SCREEN_W div 2 + shiftx, topy + 15*i, $FFFFFFFF, False);
	end;

	// mode
	topy := topy + 15*5;
	TextOut(GetTranslation('op06'), SCREEN_W div 2 - TextWidth(GetTranslation('op06'),True) - 5 + shiftx , topy, $FFB1EFDB, True);

	maxw := 0;
	for i := 0 to 1 do begin
		if TextWidth(GetTranslation('op0'+inttostr(i+7)),False) > maxw then
			maxw := TextWidth(GetTranslation('op0'+inttostr(i+7)),False);

		if opt_selected_mode = i then
		DrawRect(SCREEN_W div 2-3 + shiftx, topy + 15*i + 2, maxw+6, 14, $33B1EFDB, blendSrcAlpha); 
		TextOut(GetTranslation('op0'+inttostr(i+7)), SCREEN_W div 2 + shiftx, topy + 15*i, $FFFFFFFF, False);
	end;

	// resolution
	topy := topy + 15*3;
	TextOut(GetTranslation('op11'), SCREEN_W div 2 - TextWidth(GetTranslation('op11'),True) - 5 + shiftx , topy, $FFB1EFDB, True);

//	opt_selected_mode := strtoint(GetVariable('r_fullscreen'));

	maxw := 60;
	for i := 0 to 2 do begin

		GetWHforMon(i,ww,hh);
		res := inttostr(ww)+'x'+inttostr(hh);
		maxw := TextWidth(res,False);

		if opt_selected_resolution = i then
			DrawRect(SCREEN_W div 2-3 + shiftx, topy + 15*i + 2, maxw+6, 14, $33B1EFDB, blendSrcAlpha); 
		TextOut(res, SCREEN_W div 2 + shiftx, topy + 15*i, $FFFFFFFF, False);
	end;

	// back
	topy := topy + 15*5;
	TextCenterOut(GetTranslation('op10'), SCREEN_W div 2, topy, $FFB1EFDB, CursorInRegion(SCREEN_W div 2 - 40, topy-8, 80, 14));
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_Options_Video_Clicked;
var maxw : integer;
	shiftx : integer;
	topy : integer;
	res : string;
	ww, hh : integer;
begin
	shiftx := -60;
	topy := SCREEN_H div 3;

	maxw := 0;
	for i := 0 to 3 do begin
		if TextWidth(GetTranslation('op0'+inttostr(i+2)),False) > maxw then
			maxw := TextWidth(GetTranslation('op0'+inttostr(i+2)),False);

		if CursorInRegion(SCREEN_W div 2-3 + shiftx, topy + 15*i + 2, maxw+6, 14) then begin
			opt_selected_monitor := i;
			opt_video_changes := true;
		end;
	end;

	// mode
	topy := topy + 15*5;
	maxw := 0;
	for i := 0 to 1 do begin
		if TextWidth(GetTranslation('op0'+inttostr(i+7)),False) > maxw then
			maxw := TextWidth(GetTranslation('op0'+inttostr(i+7)),False);

		if CursorInRegion(SCREEN_W div 2-3 + shiftx, topy + 15*i + 2, maxw+6, 14) then begin
			opt_selected_mode := i;
			opt_video_changes := true;
		end;
	end;

	// resolution
	topy := topy + 15*3;

	maxw := 100;
	for i := 0 to 2 do begin
		if CursorInRegion(SCREEN_W div 2-3 + shiftx, topy + 15*i + 2, maxw+6, 14) then begin
			opt_selected_resolution := i;
			opt_video_changes := true;
		end;
	end;

	// APPLY
	topy := topy + 15*5;
	if CursorInRegion(SCREEN_W div 2 - 40, topy-8, 80, 14) then begin
		opt_page := 0;
		if opt_video_changes then begin
			cmd('r_monitor '+inttostr(opt_selected_monitor));
			cmd('r_fullscreen '+inttostr(opt_selected_mode));

			if opt_selected_resolution <= 3 then begin
				GetWHforMon(opt_selected_resolution,ww,hh);
				cmd('r_width '+inttostr(ww));
				cmd('r_height '+inttostr(hh));
			end;
				
			cmd('vid_restart');
		end;
	end;

end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_draw_options;
begin
	case opt_page of 
	1 : Menu_Options_Draw_Video;
	end;

	if opt_page > 0 then exit;

	TextCenterOut(GetTranslation('mn02'), SCREEN_W div 2, 5+SCREEN_H div 3 - 20, $FFFFFFFF, False);
	TextCenterOut(GetTranslation('op09'), SCREEN_W div 2, 5+SCREEN_H div 3+20, $FFB1EFDB, menu_item = 1);
	TextCenterOut(GetTranslation('mn04'), SCREEN_W div 2, 5+SCREEN_H div 3 + 20 * 2, $FFB1EFDB, menu_item = 2);
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_page_draw_main;
begin

	TextCenterOut(GetTranslation('mn01'), SCREEN_W div 2, 5+SCREEN_H div 3, $FFB1EFDB, menu_item = 0);
	TextCenterOut(GetTranslation('mn05'), SCREEN_W div 2, 5+SCREEN_H div 3+20, $FFB1EFDB, menu_item = 1);
	TextCenterOut(GetTranslation('mn85'), SCREEN_W div 2, 5+SCREEN_H div 3+20*2, $FFB1EFDB, menu_item = 2);
	TextCenterOut(GetTranslation('mn02'), SCREEN_W div 2, 5+SCREEN_H div 3+20*3, $FFB1EFDB, menu_item = 3);
//	TextCenterOut(GetTranslation('mn87'), SCREEN_W div 2, 5+SCREEN_H div 3+20*4, $FFB1EFDB, menu_item = 4);
	TextCenterOut(GetTranslation('mn03'), SCREEN_W div 2, 5+SCREEN_H div 3+20*4, $FFB1EFDB, menu_item = 4);
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_Page_Draw_Replays;
begin
	// i feel so numb
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_Render(g : integer);	 // called by engine
var rtop,rleft:integer;
	need_hour_glass : boolean;	
begin
//	if InGame then exit;
	DrawImage(0, SCREEN_W div 2 - 128, -64, 0, blendSrcAlpha);

	if assert_text <> '' then begin
		Menu_draw_assert;
		if (assert_need_ok = false) then
		DrawImage(1, curX, curY, 4, blendSrcAlpha) else
		DrawImage(1, curX, curY, 0, blendSrcAlpha);
		exit;
	end;

	if spawning > 0 then begin
//		loading_pat := (g div 32) mod 64;
		DrawImage(2, SCREEN_W div 2 - 16, SCREEN_H div 2 - 16, loading_pat div 4, blendSrcAlpha);
		TextCenterOut( mn14, SCREEN_W div 2, SCREEN_H div 2 + 32, $FFB1EFDB, False);
		exit;
	end;


	// hod topeg
	if (hot_topic <> '') then begin
		TextOut('   :', 2, SCREEN_H - 45-16, $FFCCCCCC, False);
		if CursorInRegion(2, SCREEN_H - 45, TextWidth(hot_topic, False), 18) then 
		TextOut(hot_topic, 2, SCREEN_H - 45, $FFFFFFFF, False) else
		TextOut(hot_topic, 2, SCREEN_H - 45, $FFB1EFDB, False);
	end;


	TextOut('v'+VERSION, SCREEN_W - TextWidth('v'+VERSION, False) - 2  , SCREEN_H - 15, $FFB1EFDB, False);
	if  CursorInRegion(2, SCREEN_H - 15, TextWidth(GAME_URL, False), 18) then 
	TextOut(GAME_URL, 2  , SCREEN_H - 15, $FFFFFFFF, False) else
	TextOut(GAME_URL, 2  , SCREEN_H - 15, $FFB1EFDB, False);

	case menu_page of 
	1 : Menu_page_draw_main;
	2 : Menu_page_draw_options;
	3 : Menu_page_draw_ServerRoom;
	4 : Menu_page_Draw_Bnet_Login;
	5 : Menu_page_Draw_Bnet_Register;
	6 : Menu_page_Draw_Bnet_Room;
	7 : Menu_page_Draw_Stats;
	end;

//	TextCenterOut(GetVariable('Name'), SCREEN_W div 2, SCREEN_H div 2, 77 shl 24 + $FFFFFF, False);

	if menu_page > 7 then Exit; // ingame pages...

	need_hour_glass := False;

	if (assert_text <> '') and (assert_need_ok = false) then
		need_hour_glass := true;

	if (menu_page = 3) and (room_playerscount = 0) then
		need_hour_glass := true;

	if need_hour_glass then
		DrawImage(1, curX, curY, 4, blendSrcAlpha)
	else // hourgralls
		DrawImage(1, curX, curY, 0, blendSrcAlpha);

	if GetVariable('d_debugcoords') = '1' then begin
		rleft := SCREEN_W div 2 - 256;
		rtop := SCREEN_H div 2 - 128;
		TextOut(inttostr(curx-rleft)+'x'+inttostr(cury-rtop ), curx +16  , cury + 15, $FFB1EFDB, False);
	
	end;

//	DrawImage(2, SCREEN_W div 2 - 16, SCREEN_H div 2 - 16, loading_pat div 4, blendSrcAlpha);
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_Process;	 // called by engine
begin
	inc(loading_pat);
	if loading_pat >=64 then loading_pat := 0;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_MouseClick(x, y : integer; button : byte);	 // called by engine
begin
	if assert_text <> '' then
	if assert_need_ok then
	if CursorInRegion(screen_w div 2 - 25, SCREEN_H div 2 + 10, 50, 18) then begin // assert box OK click
		assert_need_ok := false;
		assert_text := '';
		exit;
	end;

	if spawning > 0 then exit;
	if assert_text <> '' then exit;

	if (hot_topic <> '') then 
	if CursorInRegion(2, SCREEN_H - 45, TextWidth(hot_topic, False), 18) then 
		GoURL(hot_url);


	if CursorInRegion(2, SCREEN_H - 15, TextWidth(GAME_URL, False), 18) then GoURL(GAME_URL);

	// detect click menu items
	case menu_page of 
	1 : for i := 0 to 4 do if CursorInRegion(0, SCREEN_H div 3+20*i, SCREEN_W, 15) then Menu_page_do_click(i);  // main page
	2 : if opt_page = 0 then begin for j := 0 to 2 do if CursorInRegion(0, SCREEN_H div 3+20*j, SCREEN_W, 15) then OptionsPageDoClick(j); end else Menu_Options_Video_Clicked;
	3 : if button = 0 then Menu_Page_ServerRoom_Click;
	4 : if button = 0 then Menu_page_bnet_login_click;
	5 : if button = 0 then Menu_page_bnet_register_click;
	6 : if button = 0 then Menu_page_bnet_Room_click;
	7 : if button = 0 then Menu_page_Stats_click;
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_MouseMove(x, y : integer);	 // called by engine
var i : integer;
begin
	if spawning > 0 then exit;

	curX := x;
	curY := y;
	
	menu_item := 255;

	// detect move over menu items
	case menu_page of 
	1 : for i := 0 to 4 do if CursorInRegion(0, SCREEN_H div 3+20*i, SCREEN_W, 15) then menu_item := i;  // main page
	2 : for i := 0 to 3 do if CursorInRegion(0, SCREEN_H div 3+20*i, SCREEN_W, 15) then menu_item := i;  // main page
	end;
end;
// -----------------------------------------------------------------------------------------------
function EditStringNoSpaces ( input : string; key : char) : string;
begin
	result := input;
	if Key = '`' then exit;
	if Key = ' ' then exit;
	if key<>#13 then
	if key = #8 then input := copy(input,0,length(input)-1)
	else
	input := input + Key;
	result := input;
end;
// -----------------------------------------------------------------------------------------------
function EditString ( input : string; key : char) : string;
begin
	result := input;
	if Key = '`' then exit;
	if key<>#13 then
	if key = #8 then input := copy(input,0,length(input)-1)
	else
	input := input + Key;
	result := input;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_KeyboardKeyPress(key : char);	 // called by engine
begin
	if spawning > 0 then exit;

	// login wnd
	if menu_page = 4 then begin
		if edit_focused = 1 then begin
			 edit_login := EditStringNoSpaces (edit_login, key);
			if (key=#13) then edit_focused := 2;
		end;
		if edit_focused = 2 then begin
			edit_pass := EditStringNoSpaces (edit_pass, key);
			if (key=#13) then 
				if (edit_login <> '') and (edit_pass <> '') then cmd('login '+edit_login+' '+edit_pass); // login btn
		end;
	end;

	// register wnd
	if menu_page = 5 then begin
		if edit_focused = 1 then begin
			 edit_login := EditStringNoSpaces (edit_login, key);
			if (key=#13) then edit_focused := 2;
		end else
		if edit_focused = 2 then begin
			 edit_pass := EditStringNoSpaces (edit_pass, key);
			if (key=#13) then edit_focused := 3;
		end else
		if edit_focused = 3 then edit_mail := EditStringNoSpaces (edit_mail, key);
	end;

	if menu_page= 6 then begin
		if online_page = 1 then begin
			chat_msg := EditString (chat_msg, key);
			if chat_msg <> '' then
			if key=#13 then begin
				cmd('bsay '+chat_msg);
				chat_msg := '';
			end;
		end;

		// server creation
		if online_page = 3 then
		if edit_focused = 1 then
			edit_hostname := EditString (edit_hostname, key);
	end;

	if menu_page= 7 then
	if edit_focused = 1 then
		edit_replayname := EditString (edit_replayname, key);

	if chatroom_show then begin
		chat_msg := EditString (chat_msg, key);
		if key=#13 then begin
			cmd('say '+chat_msg);
			chat_msg := '';
		end;
	end;
end;
// -----------------------------------------------------------------------------------------------
procedure Menu_TabPressed;
begin
	// login wnd
	if menu_page = 4 then begin
		if edit_focused = 1 then edit_focused := 2 else
		if edit_focused = 2 then edit_focused := 1;
	end;	
	// register wnd
	if menu_page = 5 then begin
		if edit_focused = 1 then edit_focused := 2 else
		if edit_focused = 2 then edit_focused := 3 else
		if edit_focused = 3 then edit_focused := 1;
	end;	

end;
// -----------------------------------------------------------------------------------------------
procedure Menu_KeyboardKeyDown(key : word);	 // called by engine
begin

end;
